#Include Once "utils.bi"
#Include Once "star_tab.bi"
Type moon_t
	moon_type As UInteger
	orbit As Double
	orbit_periode As Double
	radius As Double
	density As Double
	mass As Double
	gravity As Double
	exentry As Double
	axial_tilt As Double
	rotation_periode As Double
	escape_velocity As Double
	roche_limit As Double
	tidal_lock As Double
	tidal_locked As boolean
	core_type As Integer
	tectonic_activity As Double
	tectonic As Integer
	magnetic_factor As Double
	magnetic_field As Double
	Declare Sub generate_moon(inner As Double,hab_min As Double,hab_max As Double,abudance As Integer,age As Double,lum As Double,ma As Double,d As Double,o As Double,tidal_lock As boolean)
End Type
Type planet_t
	planet_type As UInteger
	orbit_type As UInteger
	orbit As Double
	orbit_periode As Double
	orbit_both As boolean
	exentry As Double
	axial_tilt As Double
	rotation_periode As Double
	mass As Double
	radius As Double
	gravity As Double
	escape_velocity As Double
	density As Double
	tidal_lock As Double
	tidal_locked As boolean
	core_type As Integer
	tectonic_activity As Double
	tectonic As Integer
	magnetic_factor As Double
	magnetic_field As Double
	base_temperature As Double
	habitable As boolean
	solar_day As Double
	nr_moons As Integer
	moon As moon_t Ptr
	Declare Sub generate_planet(inner As Double,hab_min As Double,hab_max As Double,abudance As Integer,age As Double,lum As Double,ma As Double)
	Declare Sub delete_moons()
	Declare Sub create_moons(n As Integer)
	Declare Sub remove_moons(r As Double)
End Type
Type star_t
	star_class As UInteger
	star_specification As UInteger
	temperature As Double
	mass As Double
	luminousity As Double
	radius As Double
	orbit As Double
	exentry As Double
	orbit_periode As Double
	age As Double
	life_span As Double
	abudance As Integer
	inner_zone As Double
	habitable_zone_min As Double
	habitable_zone_max As Double
	modifier As Integer
	nr_planets As Integer
	planet As planet_t Ptr
	Declare Sub generate_star()
	Declare Sub delete_planets()
	Declare Sub create_planets(n As Integer)
	Declare Sub remove_planets(hot As Double,binar As boolean)
	Declare Sub update_planet_orbits(binar As boolean)
End Type
Type system_t
	nr_stars As Integer
	star As star_t Ptr
	Declare Sub generate_system(n As Integer)
	Declare Sub delete_stars()
	Declare Sub create_stars(n As Integer)
End Type


Type galaxy_t
	systems As system_t Ptr Ptr
	xy_size As UInteger
	nr_arms As UByte
	yp As Integer
	xp As Integer
	s_mp As Integer
	s_xp As Integer
	seed As UInteger
	epoch As Double
	map_open As Integer
	Declare Sub draw_map(x As Integer,y As Integer,xsize As Integer, ysize As Integer,x_off As Integer,y_off As Integer)
	Declare Sub generate_map(xy_size As UInteger,nr_arms As UByte)
	Declare Sub regenerate_map()
	Declare Sub generate_systems(x As Integer,y As Integer,nr As Integer)
	Declare Sub clear_systems()
End Type
Sub galaxy_t.regenerate_map()
	generate_map(xy_size,GetScrollBarVal(ScrollSpiralArms))
End Sub
Sub galaxy_t.draw_map(xpos As Integer,ypos As Integer,xsize As Integer, ysize As Integer,x_off As Integer,y_off As Integer)
	epoch+=0.1
	'draw_window(0,0,xy_size+2,xy_size+2)
	For x As Integer = 0 To xsize-1
		For y As Integer =0 To ysize-1
			If systems[x+x_off][y+y_off].nr_stars>0 Then
				Dim k As UInteger=Int(Timer*10) Mod systems[x+x_off][y+y_off].nr_stars
				Dim sc As UInteger=star_chars(systems[x+x_off][y+y_off].star[k].star_class)
				DrawText(x+xpos,y+ypos,Chr(sc), Temperature2RGB(systems[x+x_off][y+y_off].star[k].temperature) )
			Else
				Continue For
			EndIf
		Next
	Next
	For i As Integer =0 To xsize-1
		If ypos+yp-y_off>=ypos And ypos+yp-y_off<=ypos+ysize-1 Then
			DrawTile(xpos+i,ypos+yp-y_off,&h3f00ff00)
		EndIf
	Next
	For i As Integer =0 To ysize-1
		If xpos+xp-x_off>=xpos And xpos+xp-x_off<=xpos+xsize-1 Then
			DrawTile(xpos+xp-x_off,ypos+i,&h3f00ff00)
		EndIf
	Next
	'If sectors[xp][yp].nr_systems>0 Then
	'	For y As Integer =0 To 11*2
	'		DrawTile(xy_size+y,systems[xp][yp].y_pos*2+1,&h1f00ff00)
	'		DrawTile(xy_size+systems[xp][yp].x_pos*2,y,&h1f00ff00)
	'	Next
	'EndIf
	If MOUSEX\tile_w>=xpos And MOUSEX\tile_w<=xpos+xsize-1 Then
		If MOUSEY\tile_h>=ypos And MOUSEY\tile_h<=ypos+ysize-1 Then
			DrawTile(MOUSEX\tile_w,MOUSEY\tile_h,&hff00ff00)
			If LMB=RELEASE Then
				xp=MOUSEX\tile_w+x_off
				yp=MOUSEY\tile_h+y_off
				TO_ClearText(list)
				TO_AppendLine(list,"S P M")
				If systems[xp][yp].nr_stars>0 Then
					For i As UInteger=0 To systems[xp][yp].nr_stars-1
						Dim sc As UInteger=star_chars(systems[xp][yp].star[i].star_class)
						TO_AppendLine(list,Chr(sc))
						If systems[xp][yp].star[i].nr_planets>0 Then
							'TO_AppendLine(list,"LBL:PLANETS")
							For j As UInteger=0 To systems[xp][yp].star[i].nr_planets-1
								Dim sc As UInteger=planet_chars(systems[xp][yp].star[i].planet[j].planet_type)
								TO_AppendLine(list,"  " & Chr(sc))
						If systems[xp][yp].star[i].planet[j].nr_moons>0 Then
							'TO_AppendLine(list,"LBL:PLANETS")
							For k As UInteger=0 To systems[xp][yp].star[i].planet[j].nr_moons-1
								Dim sc As UInteger=moon_chars(systems[xp][yp].star[i].planet[j].moon[k].moon_type)
								TO_AppendLine(list,"    " & Chr(sc))
							Next
						endif
							Next
						endif
					Next
				EndIf
				UpdateGadget(list)
				SetListBoxVal(list,1)
			EndIf
			DrawText(xpos+xsize-7,ypos+ysize-1,Str(MOUSEX\tile_w+x_off) & "," & Str(MOUSEY\tile_h+y_off),&hffffffff)
		EndIf
	EndIf
	DrawText(xpos,ypos+ysize-1,Str(xp) & "," & Str(yp),&hff00ff00)
	'Else
	'DrawTile(MOUSEX\tile_w,MOUSEY\tile_h,&hffff0000)
	'EndIf

	'If KEY="+" Then
	'	'		If s_xp<sectors[xp][yp].nr_systems-1 Then s_xp+=1
	'EndIf
	'If KEY="-" Then
	'	If s_xp>0 Then s_xp-=1
	'EndIf

	'If systems[xp][yp].nr_stars>0 Then
	'	If systems[xp][yp].nr_stars>1 Then
	'		Dim k As UInteger=Int(epoch*3) Mod systems[xp][yp].nr_stars
	'		Dim sc As UInteger=star_chars(systems[xp][yp].star[k].star_class)
	'		DrawText(xy_size+xp*2,1+yp*2,Chr(sc),Temperature2RGB(systems[xp][yp].star[k].temperature))
	'	Else
	'		Dim sc As UInteger=star_chars(systems[xp][yp].star[0].star_class)
	'		DrawText(xy_size+xp*2,1+yp*2,Chr(sc),Temperature2RGB(systems[xp][yp].star[0].temperature))
	'	EndIf
	'EndIf

	'If systems[xp][yp].nr_stars>1 Then
	'	DrawText(xy_size+1,25,Chr(star_chars(systems[xp][yp].star[0].star_class)),Temperature2RGB(systems[xp][yp].star[0].temperature))
	'	DrawText(xy_size+2,25,Chr(star_chars(systems[xp][yp].star[1].star_class)),Temperature2RGB(systems[xp][yp].star[1].temperature))

	'	DrawText(xy_size+Sin(seed+epoch*10*degToRad/systems[xp][yp].star[0].orbit_periode)*systems[xp][yp].star[0].orbit+25,Cos(seed+epoch*10*degToRad/systems[xp][yp].star[0].orbit_periode)*systems[xp][yp].star[0].orbit+25+25,Chr(star_chars(systems[xp][yp].star[0].star_class)),Temperature2RGB(systems[xp][yp].star[0].temperature))
	'	DrawText(xy_size+Sin(seed+epoch*10*degToRad/systems[xp][yp].star[1].orbit_periode)*systems[xp][yp].star[1].orbit+25,Cos(seed+epoch*10*degToRad/systems[xp][yp].star[1].orbit_periode)*systems[xp][yp].star[1].orbit+25+25,Chr(star_chars(systems[xp][yp].star[1].star_class)),Temperature2RGB(systems[xp][yp].star[1].temperature))

	'	If systems[xp][yp].star[0].nr_planets>0 Then
	'		For i As UInteger=0 To systems[xp][yp].star[0].nr_planets-1
	'			DrawText(xy_size+mapa(systems[xp][yp].star[0].planet[i].orbit,systems[xp][yp].star[0].planet[0].orbit,systems[xp][yp].star[0].planet[systems[xp][yp].star[0].nr_planets-1].orbit,0,21),26,Chr(planet_chars(systems[xp][yp].star[0].planet[i].planet_type)),&h7f7f7f7f)
	'			DrawText(xy_size+(20*3),25,Str(systems[xp][yp].star[0].nr_planets),&h7f7f7f7f)
	'			'DrawText(xy_size+mapa(systems[xp][yp].star[0].planet[i].orbit,0,25,0,21),27,IIf(systems[xp][yp].star[0].planet[i].orbit_both,"T","F"),&h7f7f7f7f)

	'			'If systems[xp][yp].star[0].planet[i].orbit_both=TRUE Then
	'			'	DrawText(xy_size+Sin(seed+epoch*10*degToRad/systems[xp][yp].star[0].planet[i].orbit_periode)*(systems[xp][yp].star[0].planet[i].orbit+systems[xp][yp].star[0].orbit)+25,Cos(seed+epoch*10*degToRad/systems[xp][yp].star[0].planet[i].orbit_periode)*(systems[xp][yp].star[0].planet[i].orbit+systems[xp][yp].star[0].orbit)+25+25,Chr(planet_chars(systems[xp][yp].star[0].planet[i].planet_type)),&h3fffffff)
	'			'Else
	'			'	DrawText(xy_size+Sin(seed+epoch*10*degToRad/systems[xp][yp].star[0].orbit_periode)*systems[xp][yp].star[0].orbit+Sin(seed+epoch*10*degToRad/systems[xp][yp].star[0].planet[i].orbit_periode)*systems[xp][yp].star[0].planet[i].orbit+25,Cos(seed+epoch*10*degToRad/systems[xp][yp].star[0].orbit_periode)*systems[xp][yp].star[0].orbit+Cos(seed+epoch*10*degToRad/systems[xp][yp].star[0].planet[i].orbit_periode)*systems[xp][yp].star[0].planet[i].orbit+25+25,Chr(planet_chars(systems[xp][yp].star[0].planet[i].planet_type)),&h3fffffff)
	'			'EndIf
	'			'		DrawText(xy_size+27,25+26+i,Str(systems[xp][yp].star[0].planet[i].orbit),&hffffffff)
	'		Next
	'	EndIf
	'Else
	'	If systems[xp][yp].nr_stars>0 Then
	'		DrawText(xy_size+1,25,Chr(star_chars(systems[xp][yp].star[0].star_class)),Temperature2RGB(systems[xp][yp].star[0].temperature))
	'		DrawText(xy_size+25,25+25,Chr(star_chars(systems[xp][yp].star[0].star_class)),Temperature2RGB(systems[xp][yp].star[0].temperature))

	'		If systems[xp][yp].star[0].nr_planets>0 Then
	'			For i As UInteger=0 To systems[xp][yp].star[0].nr_planets-1
	'				DrawText(xy_size+mapa(systems[xp][yp].star[0].planet[i].orbit,systems[xp][yp].star[0].planet[0].orbit,systems[xp][yp].star[0].planet[systems[xp][yp].star[0].nr_planets-1].orbit,0,21),26,Chr(planet_chars(systems[xp][yp].star[0].planet[i].planet_type)),&h7f7f7f7f)
	'				DrawText(xy_size+(20*3),25,Str(systems[xp][yp].star[0].nr_planets),&h7f7f7f7f)

	'				'DrawText(xy_size+Sin(seed+epoch*10*degToRad/systems[xp][yp].star[0].planet[i].orbit_periode)*(systems[xp][yp].star[0].planet[i].orbit)+25,Cos(seed+epoch*10*degToRad/systems[xp][yp].star[0].planet[i].orbit_periode)*(systems[xp][yp].star[0].planet[i].orbit)+25+25,Chr(planet_chars(systems[xp][yp].star[0].planet[i].planet_type)),&h3fffffff)
	'			Next
	'		EndIf
	'		'DrawText(xy_size+27,25+25,Str(systems[xp][yp].star[0].orbit*(1+systems[xp][yp].star[0].exentry)),&hffffffff)
	'	EndIf
	'EndIf
	'If systems[xp][yp].nr_stars>0 Then
	'	If systems[xp][yp].star[0].nr_planets>0 Then
	'		For i As UInteger=0 To systems[xp][yp].star[0].nr_planets-1
	'			If systems[xp][yp].star[0].planet[i].nr_moons>0 Then
	'				For j As UInteger=0 To systems[xp][yp].star[0].planet[i].nr_moons-1
	'					DrawText(xy_size+mapa(systems[xp][yp].star[0].planet[i].orbit,systems[xp][yp].star[0].planet[0].orbit,systems[xp][yp].star[0].planet[systems[xp][yp].star[0].nr_planets-1].orbit,0,21),27+j,Chr(moon_chars(systems[xp][yp].star[0].planet[i].moon[j].moon_type)),Temperature2RGB(systems[xp][yp].star[0].temperature))
	'				Next
	'			EndIf
	'		Next
	'	EndIf
	'EndIf
End Sub

Sub galaxy_t.generate_map(xysize As UInteger, nrarms As UByte)
	Dim map As UInteger Ptr Ptr
	If map=0 Then
		map=Callocate(xysize,SizeOf(UInteger Ptr))
		For i As UInteger=0 To xysize-1
			map[i]=Callocate(xysize,SizeOf(UInteger))
		Next
	EndIf
	seed=Timer*1000
	epoch=Timer*1000
	Randomize seed
	xy_size=xysize
	nr_arms=nrarms
	yp=xy_size\3
	xp=xy_size\3+1

	clear_systems()
	Dim x As Integer
	Dim y As Integer
	Dim x1 As Integer
	Dim y1 As Integer
	For j As UInteger=0 To 360-360\nr_arms Step 360\nr_arms
		For i As UInteger=0 To 1440 Step 1
			Dim r1 As Double=(((i^2)/(GetScrollBarVal(ScrollSpiralK)/GetScrollBarVal(ScrollSpiralP))^2))/16
			If r1>=1.0 Then Exit For
			For s As UInteger=0 To mapa(sigmoid(mapa(r1,0,1.0,0,-8),GetScrollBarVal(ScrollBulgeSize),GetScrollBarVal(ScrollBulgeOffset)/10 ),0,1,0,128) Step 1'nr_arms
				x=mapa((-0.5+Rnd)*sigmoid(mapa(r1,0,1.0,0,-8),GetScrollBarVal(ScrollBulgeSize),GetScrollBarVal(ScrollBulgeOffset)/10 ),0,1,0,GetScrollBarVal(ScrollBulgeSize))
				y=mapa((-0.5+Rnd)*sigmoid(mapa(r1,0,1.0,0,-8),GetScrollBarVal(ScrollBulgeSize),GetScrollBarVal(ScrollBulgeOffset)/10 ),0,1,0,GetScrollBarVal(ScrollBulgeSize))
				x1=Sin((i+j)*degToRad)*r1*(xy_size\2)+(xy_size\2)+x
				y1=Cos((i+j)*degToRad)*r1*(xy_size\2)+(xy_size\2)+y
				If x1<0 Or x1 > xy_size-1 Then Continue For
				If y1<0 Or y1 > xy_size-1 Then Continue For
				If (map[x1][y1] Shr 24)<255 Then
					map[x1][y1]+=RGBA(1,1,1,1)
				EndIf
			Next
		Next
	Next
	For i As UInteger=0 To xysize-1
		For j As UInteger=0 To xysize-1
			generate_systems(i,j,map[i][j] Shr 24)
		Next
	Next
	If map<>0 Then
		For i As UInteger=0 To xysize-1
			DeAllocate(map[i])
			map[i]=0
		Next
		DeAllocate(map)
		map=0
	EndIf
End Sub
Sub galaxy_t.clear_systems()
	If systems<>0 Then
		For i As UInteger=0 To xy_size*16-1
			For j As UInteger=0 To xy_size*16-1
				systems[i][j].delete_stars()
			Next
		Next
		For i As UInteger=0 To xy_size*16-1
			DeAllocate(systems[i])
			systems[i]=0
		Next
		DeAllocate(systems)
		systems=0
	EndIf
	If systems=0 Then
		systems=Callocate(xy_size*16,SizeOf(system_t Ptr))
		For i As UInteger=0 To xy_size*16-1
			systems[i]=Callocate(xy_size*16,SizeOf(system_t))
		Next
	EndIf
End Sub


Sub galaxy_t.generate_systems(x As Integer,y As Integer,nr As Integer)
	Dim nr_systems As UInteger=mapa(nr,0,255,0,16)
	If nr_systems>0 Then
		Dim x1 As UInteger
		Dim y1 As UInteger
		While nr_systems>0
			x1 =rndRange(0,16-1)
			y1 =rndRange(0,16-1)
			Dim nr_stars As UInteger=1
			Dim r As UInteger=rndRange(1,10)
			If r>=7 Then nr_stars=2
			If systems[x*16+x1][y*16+y1].star=0 Then
				systems[x*16+x1][y*16+y1].generate_system(nr_stars)
				nr_systems-=1
			EndIf
		Wend
	EndIf
End Sub
Sub system_t.generate_system(n As Integer)
	'	If n>0 Then
	create_stars(n)
	Dim temperature As Double=0
	Dim r1 As UInteger=rndRange(1,100)
	Dim r2 As UInteger=rndRange(1,10)
	Dim r3 As UInteger=rndRange(0,9)
	Dim r4 As UInteger=rndRange(1,10)
	Dim r5 As UInteger=rndRange(0,star_class.nr_entrys-2)
	Dim c As Integer
	If r1=1 Then
		c=star_class.AV
		If r2>=7 Then c=star_class.AIV
	EndIf
	If r1>=2 And r1<=4 Then
		c=star_class.FV
		If r2>=9 Then c=star_class.FIV
	EndIf
	If r1>=5 And r1<=12 Then
		c=star_class.GV
		If r2=10 Then c=star_class.GIV
	EndIf
	If r1>=13 And r1<=26 Then
		c=star_class.KV
	EndIf
	'white dwarf
	If r1>=27 And r1<=36 Then
		c=star_class.WDVII
	EndIf
	If r1>=37 And r1<=85 Then
		c=star_class.AV
	EndIf
	'brown dwarf
	If r1>=86 And r1<=98 Then
		c=star_class.BD
	EndIf
	If r1=99 Then
		If r2=1 Then c=star_class.FIII
		If r2=2 Then c=star_class.GIII
		If r2>=3 And r2<=5 Then c=star_class.KIII
		If r2>=6 And r2<=7 Then c=star_class.MIII
		If r2>=8 Then c=star_class.KIV
	EndIf
	'special
	If r1=100 Then c=star_class.BV
	If nr_stars>0 Then
		star[0].star_class=c

		star[0].star_specification=r3
		star[0].temperature=star_temperatures(c,r3)
		star[0].luminousity=star_luminousity(c,r3)
		star[0].mass=star_mass(c,r3)
		star[0].radius=star_radius(c,r3)
		temperature+=star_temperatures(c,r3)
	EndIf
	If nr_stars>1 Then
		If r4<3 Then
			If r5<c Then
				star[1].star_class=c
				star[1].star_specification=r3
				star[1].temperature=star_temperatures(c,r3)
				star[1].luminousity=star_luminousity(c,r3)
				star[1].mass=star_mass(c,r3)
				star[1].radius=star_radius(c,r3)
				temperature+=star_temperatures(c,r3)
			Else
				r3=rndRange(0,9)
				star[1].star_class=r5
				star[1].star_specification=r3
				star[1].temperature=star_temperatures(r5,r3)
				star[1].luminousity=star_luminousity(r5,r3)
				star[1].mass=star_mass(r5,r3)
				star[1].radius=star_radius(r5,r3)
				temperature+=star_temperatures(r5,r3)
			EndIf
		Else
			'brown dwarf
			If r5>star_class.KIV Then
				r3=rndRange(0,9)
				star[1].star_class=star_class.BD
				star[1].star_specification=r3
				star[1].temperature=star_temperatures(star_class.BD,r3)
				star[1].luminousity=star_luminousity(star_class.BD,r3)
				star[1].mass=star_mass(star_class.BD,r3)
				star[1].radius=star_radius(star_class.BD,r3)
				temperature+=star_temperatures(star_class.BD,r3)
			Else
				r3=rndRange(0,9)
				star[1].star_class=r5
				star[1].star_specification=r3
				star[1].temperature=star_temperatures(r5,r3)
				star[1].luminousity=star_luminousity(r5,r3)
				star[1].mass=star_mass(r5,r3)
				star[1].radius=star_radius(r5,r3)
				temperature+=star_temperatures(r5,r3)
			EndIf
		EndIf
		'calculate star orbits
		If nr_stars>1 Then
			If star[0].mass<star[1].mass Then
				Swap star[0],star[1]
			EndIf
			r1=rndRange(1,10)
			Dim o As Double
			If r1>=1 And r1<=3 Then o=rndRange(1,2)*2
			If r1>=4 And r1<=6 Then o=rndRange(1,5)*3
			If r1>=7 And r1<=8 Then o=rndRange(1,10)*5
			If r1=9 Then o=rndRange(1,10)*20
			If r1=10 Then o=rndRange(1,10)*200
			star[0].orbit=+o
			star[1].orbit=-o
			star[0].orbit_periode=Sqr((star[0].orbit*star[0].orbit*star[0].orbit)/(star[0].mass+star[1].mass))
			star[1].orbit_periode=Sqr((star[0].orbit*star[0].orbit*star[0].orbit)/(star[0].mass+star[1].mass))
			r1=rndRange(1,10)
			r2=rndRange(1,10)
			If r1>=1 And r1<=2 Then o=r2*0.01
			If r1>=3 And r1<=4 Then o=0.1+r2*0.01
			If r1>=5 And r1<=6 Then o=0.2+r2*0.01
			If r1>=7 And r1<=8 Then o=0.3+r2*0.01
			If r1=9  Then o=0.4+r2*0.01
			If r1=10  Then o=0.5+r2*0.04
			star[0].exentry=o
			star[0].inner_zone=4*Sqr(star[0].luminousity)
		EndIf
		'star[1].delete_planets()
		'star[1].nr_planets=0
	EndIf

	For i As UInteger=0 To n-1
		If star[i].star_class=star_class.KIV Then star[i].star_specification=0
		'randomizing subgiants
		If star[i].star_class>=star_class.AIV And star[i].star_class<=star_class.KIV Then
			r1 =rndRange(1,10)
			star[i].mass*=rnd_subgiants_multiplier(0,r1)
			star[i].luminousity*=rnd_subgiants_multiplier(1,r1)
			star[i].radius= Sqr(star[i].luminousity)* ((5800/star[i].temperature)*(5800/star[i].temperature))
		EndIf
		'randomizing giants
		If star[i].star_class>=star_class.AIII And star[i].star_class<=star_class.MIII Then
			r1 =rndRange(1,10)
			star[i].mass*=rnd_giants_multiplier(0,r1)
			star[i].luminousity*=rnd_giants_multiplier(1,r1)
			star[i].radius= Sqr(star[i].luminousity)* ((5800/star[i].temperature)*(5800/star[i].temperature))
		EndIf
		'calculate the luminousity of withe and brown dwarfs
		If star[i].star_class>=star_class.WDVII And star[i].star_class<=star_class.BD Then
			star[i].luminousity=Abs((star[i].radius*star[i].radius)*(star[i].temperature*star[i].temperature*star[i].temperature*star[i].temperature)/(5800*5800*5800*5800))
		EndIf
	Next
	'calculate the system age
	For i As UInteger=0 To n-1
		star[i].life_span=10*(star[i].mass/star[i].luminousity)
	Next
	r1=rndRange(1,10)
	If star[0].star_class=star_class.AV Or star[0].star_class=star_class.AIV Or star[0].star_class=star_class.AIII Then
		If star[0].star_specification>=0 And star[0].star_specification<=4 Then
			star[0].age=system_age(2,r1)
			star[0].luminousity*=system_age_luminousity_modifier(2,r1)
		EndIf
		If star[0].star_specification>=5 And star[0].star_specification<=9 Then
			star[0].age=system_age(3,r1)
			star[0].luminousity*=system_age_luminousity_modifier(3,r1)
		EndIf
	EndIf
	If star[0].star_class=star_class.FV Or star[0].star_class=star_class.FIV Or star[0].star_class=star_class.FIII Then
		If star[0].star_specification>=0 And star[0].star_specification<=4 Then
			star[0].age=system_age(4,r1)
			star[0].luminousity*=system_age_luminousity_modifier(2,r1)
		EndIf
		If star[0].star_specification>=5 And star[0].star_specification<=9 Then
			star[0].age=system_age(5,r1)
			star[0].luminousity*=system_age_luminousity_modifier(3,r1)
		EndIf
	EndIf
	If star[0].star_class=star_class.GV Or star[0].star_class=star_class.GIV Or star[0].star_class=star_class.GIII Then
		If star[0].star_specification>=0 And star[0].star_specification<=4 Then
			star[0].age=system_age(6,r1)
			star[0].luminousity*=system_age_luminousity_modifier(2,r1)
		EndIf
		If star[0].star_specification>=5 And star[0].star_specification<=9 Then
			star[0].age=system_age(7,r1)
			star[0].luminousity*=system_age_luminousity_modifier(3,r1)
		EndIf
	EndIf
	If star[0].star_class=star_class.KV Or star[0].star_class=star_class.KIV Or star[0].star_class=star_class.KIII Then
		If star[0].star_specification>=0 And star[0].star_specification<=4 Then
			star[0].age=system_age(8,r1)
			star[0].luminousity*=system_age_luminousity_modifier(2,r1)
		EndIf
		If star[0].star_specification>=5 And star[0].star_specification<=9 Then
			star[0].age=system_age(9,r1)
			star[0].luminousity*=system_age_luminousity_modifier(3,r1)
		EndIf
	EndIf
	If star[0].star_class=star_class.MV Or star[0].star_class=star_class.MIII Then
		If star[0].star_specification>=0 And star[0].star_specification<=9 Then
			star[0].age=system_age(10,r1)
			star[0].luminousity*=system_age_luminousity_modifier(2,r1)
		EndIf
	EndIf
	If star[0].star_class=star_class.WDVII Then
		If star[0].star_specification>=0 And star[0].star_specification<=9 Then
			star[0].age=system_age(11,r1)
			star[0].luminousity*=system_age_luminousity_modifier(2,r1)
		EndIf
	EndIf
	If star[0].star_class=star_class.BD Then
		If star[0].star_specification>=0 And star[0].star_specification<=9 Then
			star[0].age=system_age(12,r1)
			star[0].luminousity*=system_age_luminousity_modifier(2,r1)
		EndIf
	EndIf
	If nr_stars>1 Then
		star[1].age=star[0].age
	EndIf
	'get the abudance
	r1=rndRange(1,10)+rndRange(1,10)+Int(star[0].age+0.5)
	If r1>=3 And r1<=9 Then star[0].abudance=2
	If r1>=10 And r1<=12 Then star[0].abudance=1
	If r1>=13 And r1<=18 Then star[0].abudance=0
	If r1>=19 And r1<=21 Then star[0].abudance=-1
	If r1>=22 Then star[0].abudance=-3
	star[0].habitable_zone_min=0.75*Sqr(star[0].luminousity)
	star[0].habitable_zone_max=1.4*Sqr(star[0].luminousity)
	'planetcreation
	r1=rndRange(1,10)
	If star[0].star_class=star_class.KV Then
		If star[0].star_specification>=5 And star[0].star_specification<=9 Then
			r1+=1
		EndIf
	EndIf
	If star[0].star_class=star_class.MV Then
		If star[0].star_specification>=0 And star[0].star_specification<=4 Then
			r1+=2
		EndIf
	EndIf
	If star[0].star_class=star_class.MV Then
		If star[0].star_specification>=5 And star[0].star_specification<=9 Then
			r1+=3
		EndIf
	EndIf
	If star[0].star_class=star_class.BD Then
		r1+=5
	EndIf
	r1+=star[0].abudance
	r2=0
	If r1=1 Then r2=rndRange(1,10)+10
	If r1>=2 And r1<=5 Then r2=rndRange(1,10)+5
	If r1>=6 And r1<=7 Then r2=rndRange(1,10)
	If r1>=8 And r1<=9 Then r2=rndRange(1,5)

	'		If r2>0 Then
	'create planet orbits
	If nr_stars>0 Then
		star[0].create_planets(r2)
		If star[0].nr_planets>0 Then
			star[0].planet[0].orbit=0.05*(star[0].mass*star[0].mass)*rndRange(1,10)
			star[0].planet[0].generate_planet(star[0].inner_zone,star[0].habitable_zone_min,star[0].habitable_zone_max,star[0].abudance,star[0].age,star[0].luminousity,star[0].mass)
			star[0].planet[0].orbit_periode=Sqr((star[0].planet[0].orbit*star[0].planet[0].orbit*star[0].planet[0].orbit)/(star[0].mass+star[0].planet[0].mass))
			If star[0].nr_planets>1 Then
				For k As UInteger=1 To star[0].nr_planets-1
					star[0].planet[k].orbit=star[0].planet[k-1].orbit+1.1+(rndRange(1,10)*0.1)+0.1
					star[0].planet[k].generate_planet(star[0].inner_zone,star[0].habitable_zone_min,star[0].habitable_zone_max,star[0].abudance,star[0].age,star[0].luminousity,star[0].mass)
					star[0].planet[k].orbit_periode=Sqr((star[0].planet[k].orbit*star[0].planet[k].orbit*star[0].planet[k].orbit)/(star[0].mass+star[0].planet[k].mass))
				Next
			EndIf
		EndIf
		'remove all planets in untentable orbits
		Dim hot As Double
		Dim bina As boolean=nr_stars>1
		If star[0].star_class>=star_class.WDVII And star[0].star_class<=star_class.BD Then
			r1=rndRange(1,10)
			If star[0].mass >=0.6 And star[0].mass<=0.9 Then r1+=2
			If star[0].mass>0.9 Then r1+=4
			If r1>=1 And r1<=4 Then hot=2
			If r1>=5 And r1<=8 Then hot=4
			If r1>=9 And r1<=11 Then hot=6
			If r1>=12 Then hot=10
			If bina Then hot*=2
			star[0].remove_planets(hot,bina)
			star[0].update_planet_orbits(bina)
		Else
			hot=0.025 * Sqr(star[0].luminousity)
			If bina Then hot=0.025 * Sqr(star[0].luminousity+star[1].luminousity)
			star[0].remove_planets(hot,bina)
			star[0].update_planet_orbits(bina)
		EndIf

	EndIf
End Sub
Sub system_t.delete_stars()
	If star<>0 Then
		For i As UInteger=0 To nr_stars-1
			star[i].delete_planets()
		Next
		DeAllocate(star)
		star=0
	EndIf
	nr_stars=0
End Sub
Sub system_t.create_stars(n As Integer)
	If n>0 Then
		If star=0 Then
			star=Callocate(n,SizeOf(star_t))
		EndIf
	EndIf
	nr_stars=n
End Sub
Sub star_t.delete_planets()
	If planet<>0 Then
		For i As UInteger=0 To nr_planets-1
			planet[i].delete_moons()
		Next
		DeAllocate(planet)
		planet=0
	EndIf
	nr_planets=0
End Sub
Sub star_t.create_planets(n As Integer)
	If n>0 Then
		If planet=0 Then
			planet=Callocate(n,SizeOf(planet_t))
		EndIf
	EndIf
	nr_planets=n
End Sub
Sub planet_t.delete_moons()
	If moon<>0 Then
		DeAllocate(moon)
		moon=0
	EndIf
	nr_moons=0
End Sub
Sub planet_t.create_moons(n As Integer)
	If n>0 Then
		If moon=0 Then
			moon=Callocate(n,SizeOf(moon_t))
		EndIf
	EndIf
	nr_moons=n
End Sub

Sub star_t.remove_planets(hot As Double,binar As boolean)
	Dim n As UInteger=nr_planets
	Dim p As planet_t Ptr=planet
	If binar=TRUE Then
		If n>0 Then
			While ( (p[0].orbit>=(orbit*(1-exentry)/3) And (p[0].orbit<=orbit*(1+exentry)*3))) Or (p[0].orbit<=radius) Or (p[0].orbit<hot)
				'While ((p[0].orbit<orbit) ) Or (p[0].orbit<=radius) Or (p[0].orbit<hot)
				If n=1 Then
					If p[0].nr_moons>0 Then
						DeAllocate(p[0].moon)
						p[0].moon=0
					EndIf
					DeAllocate(p)
					p=0
					n=0
					Exit While
				Else
					If n>1 Then
						If p[0].nr_moons>0 Then
							DeAllocate(p[0].moon)
							p[0].moon=0
						EndIf
						For j As UInteger=1 To n-1
							p[j-1]= p[j]
						Next
						n-=1
						p=ReAllocate(planet,(n)*SizeOf(planet_t))
					EndIf
				EndIf
				planet=p
			Wend
		EndIf
	Else
		If n>0 Then
			While (p[0].orbit<hot) Or (p[0].orbit<=radius)
				If n=1 Then
					If p[0].nr_moons>0 Then
						DeAllocate(p[0].moon)
						p[0].moon=0
					EndIf
					DeAllocate(p)
					p=0
					n=0
					Exit While
				Else
					If n>1 Then
						'Print "here",n,n-1
						If p[0].nr_moons>0 Then
							DeAllocate(p[0].moon)
							p[0].moon=0
						EndIf
						For j As UInteger=1 To n-1
							p[j-1]= p[j]
						Next
						n-=1
						p=ReAllocate(planet,(n)*SizeOf(planet_t))
					EndIf
				EndIf
				planet=p
			Wend
		EndIf
	EndIf
	planet=p
	nr_planets=n
End Sub
Sub planet_t.remove_moons(r As Double)
	Dim n As UInteger=nr_moons
	Dim p As moon_t Ptr=moon

	If n>0 Then
		While (p[0].orbit<=radius)
			If n=1 Then
				DeAllocate(p)
				p=0
				n=0
				Exit While
			Else
				If n>1 Then
					'Print "here",n,n-1
					For j As UInteger=1 To n-1
						p[j-1]= p[j]
					Next
					n-=1
					p=ReAllocate(moon,(n)*SizeOf(moon_t))
				EndIf
			EndIf
			moon=p
		Wend
	EndIf
	moon=p
	nr_moons=n
End Sub
Sub star_t.update_planet_orbits(binar As boolean)
	If binar=TRUE Then
		If nr_planets>0 Then
			For i As UInteger=0 To nr_planets-1
				If (planet[i].orbit>((orbit*(1+exentry))*3)) Then
					planet[i].orbit_both=TRUE
				Else
					planet[i].orbit_both=FALSE
				EndIf
			Next
		EndIf
	EndIf
End Sub

Sub planet_t.generate_planet(inner As Double,hab_min As Double,hab_max As Double,abudance As Integer,age As Double,lum As Double,ma As Double)
	Dim r1 As Integer=rndRange(1,100)
	Dim r2 As Integer=rndRange(1,10)
	'get planet type
	If orbit<=inner Then
		If r1>=1 And r1<=21 Then planet_type=planet_class.asteorid
		If r1>=22 And r1<=72 Then planet_type=planet_class.terestrial
		If r1>=73 And r1<=82 Then planet_type=planet_class.chunk
		If r1>=83 And r1<=94 Then planet_type=planet_class.giant
		If r1>=95 And r1<=99 Then planet_type=planet_class.jovian
		If r1>=100 Then
			r1=rndRange(planet_class.terestrial,planet_class.giant)
			planet_type=r1
		EndIf
	Else
		If r1>=1 And r1<=17 Then planet_type=planet_class.asteorid
		If r1>=18 And r1<=27 Then planet_type=planet_class.terestrial
		If r1>=28 And r1<=40 Then planet_type=planet_class.chunk
		If r1>=41 And r1<=89 Then planet_type=planet_class.giant
		If r1>=90 And r1<=99 Then planet_type=planet_class.jovian
		If r1>=100 Then
			r1=rndRange(planet_class.terestrial,planet_class.giant)
			planet_type=r1
		EndIf
	EndIf
	If planet_type>=planet_class.terestrial And planet_type<=planet_class.giant Then
		radius=planet_size(planet_type-1,r2)+rndRange(1,10)*planet_size_modifier(planet_type-1,r2)
	EndIf
	If planet_type>=planet_class.jovian Then
		r2=rndRange(1,10)
		If r2>=1 And r2<=4 Then mass=500+rndRange(1,10)*50
		If r2>=5 And r2<=7 Then mass=1000+rndRange(1,10)*100
		If r2>=8 And r2<=9 Then mass=2000+rndRange(1,10)*100
		If r2>=10 Then mass=3000+rndRange(1,10)*100
		radius=60000+(rndRange(1,10)-0.5*age)*2000
	EndIf
	If orbit<=inner Then
		If planet_type>=planet_class.asteorid Then density=0.3+rndRange(1,10)*(0.127/(0.4+(orbit/Sqr(lum)))^0.67)
		If planet_type>=planet_class.chunk Then density=0.3+rndRange(1,10)*(0.127/(0.4+(orbit/Sqr(lum)))^0.67)
		If planet_type>=planet_class.terestrial Then density=0.3+rndRange(1,10)*(0.127/(0.4+(orbit/Sqr(lum)))^0.67)
		If planet_type>=planet_class.giant Then density=0.1+rndRange(1,10)*0.025
		mass=((radius/6380)*(radius/6380)*(radius/6380))*density
	Else
		If planet_type>=planet_class.asteorid Then density=0.1+rndRange(1,10)*0.05
		If planet_type>=planet_class.chunk Then density=0.1+rndRange(1,10)*0.05
		If planet_type>=planet_class.terestrial Then density=0.1+rndRange(1,10)*0.05
		If planet_type>=planet_class.giant Then density=0.08+rndRange(1,10)*0.025
		mass=((radius/6380)*(radius/6380)*(radius/6380))*density
	EndIf
	gravity=mass/((radius/6380)*(radius/6380))
	escape_velocity=Sqr(19600 * gravity * radius)/11200
	tidal_lock=(ma*26640000)/((orbit*400)*(orbit*400)*(orbit*400))
	tidal_locked=IIf((0.83+rndRange(1,10)*0.03)*tidal_lock*age/6.6>1.0,TRUE,FALSE)
	r1=rndRange(1,10)
	If r1>=1 And r1<=5 Then exentry=0.005*rndRange(1,10)
	If r1>=6 And r1<=7 Then exentry=0.05+0.01*rndRange(1,10)
	If r1>=8 And r1<=9 Then exentry=0.15+0.01*rndRange(1,10)
	If r1>=10 Then exentry=0.25+0.04*rndRange(1,10)
	If tidal_locked=FALSE Then
		r1=rndRange(1,10)
		If r1>=1 And r1<=2 Then axial_tilt=rndRange(1,10)
		If r1>=3 And r1<=4 Then axial_tilt=10+rndRange(1,10)
		If r1>=5 And r1<=6 Then axial_tilt=20+rndRange(1,10)
		If r1>=7 And r1<=8 Then axial_tilt=30+rndRange(1,10)
		If r1>=9 And r1<=10 Then axial_tilt=40+rndRange(1,100)*1.4
	EndIf
	If tidal_locked=FALSE Then
		r1=rndRange(1,10)
		Dim modif As Double=tidal_lock*age
		If planet_type=planet_class.terestrial Then
			If mass>4 Then modif-=2
			If r1>=1 And r1<=5 Then rotation_periode=10+rndRange(1,10)*2
			If r1>=6 And r1<=8 Then rotation_periode=30+rndRange(1,100)
			If r1>=9 And r1<=10 Then rotation_periode=rndRange(1,100)*2*24
		EndIf
		If planet_type=planet_class.chunk Then
			If r1>=1 And r1<=5 Then rotation_periode=rndRange(1,10)*2
			If r1>=6 And r1<=8 Then rotation_periode=10+rndRange(1,10)*24
			If r1>=9 And r1<=10 Then rotation_periode=20+rndRange(1,100)*24
		EndIf
		If planet_type=planet_class.giant Or planet_type=planet_class.jovian Then
			If mass<50 Then modif+=2
			If r1>=1 And r1<=5 Then rotation_periode=6+rndRange(1,5)
			If r1>=6 And r1<=7 Then rotation_periode=11+rndRange(1,5)
			If r1>=8 And r1<=9 Then rotation_periode=16+rndRange(1,10)
			If r1>=10 Then rotation_periode=26+rndRange(1,10)
		EndIf
		rotation_periode*=(1.0+(0.1*modif))
	EndIf
	solar_day= 1.0/((1.0/rotation_periode)-(1.0/orbit_periode))
	'create the core and mantle
	If planet_type>=planet_class.terestrial And planet_type<=planet_class.chunk Then
		If orbit<=inner Then
			If density>=0.4 And density<0.7 Then core_type=core_class.SI_smetal
			If density>=0.7 And density<1.0 Then core_type=core_class.FENI_mmetal
			If density>=1.0 And density<=1.3 Then core_type=core_class.FENI_lmetal
		Else
			If density>=0.15 And density<0.3 Then core_type=core_class.ice
			If density>=0.30 And density<0.45 Then core_type=core_class.SI_ice
			If density>=0.45 And density<=0.6 Then core_type=core_class.SI_smetal
		EndIf
		'create tectonic
		tectonic_activity=(5+rndRange(1,10))*Sqr(mass)/age
		If core_type>=core_class.ice And core_type<=core_class.SI_ice Then
			tectonic_activity*=density
		EndIf
		If rotation_periode<18 Then
			tectonic_activity*=1.25
		EndIf
		If rotation_periode>100 Then
			tectonic_activity*=1.25
		EndIf
		If tidal_locked=TRUE Then
			tectonic_activity*=0.5
		EndIf
		r1=rndRange(1,10)
		If tectonic_activity<0.5 Then tectonic=tectonic_class.dead
		If tectonic_activity>=0.5 And tectonic_activity<1.0 Then
			If r1>=1 And r1<=7 Then tectonic=tectonic_class.dead
			If r1>=8 And r1<=9 Then tectonic=tectonic_class.hotspot
			If r1>=10 Then tectonic=tectonic_class.plastic
		EndIf
		If tectonic_activity>=1.0 And tectonic_activity<2.0 Then
			If r1=1 Then tectonic=tectonic_class.dead
			If r1>=2 And r1<=5 Then tectonic=tectonic_class.hotspot
			If r1>=6 And r1<=9 Then tectonic=tectonic_class.plastic
			If r1>=10 Then tectonic=tectonic_class.plate
		EndIf
		If tectonic_activity>=2.0 And tectonic_activity<3.0 Then
			If r1>=1 And r1<=2 Then tectonic=tectonic_class.hotspot
			If r1>=3 And r1<=6 Then tectonic=tectonic_class.plastic
			If r1>=7 Then tectonic=tectonic_class.plate
		EndIf
		If tectonic_activity>=3.0 And tectonic_activity<5.0 Then
			If r1=1 Then tectonic=tectonic_class.hotspot
			If r1>=2 And r1<=3 Then tectonic=tectonic_class.plastic
			If r1>=4 And r1<=8 Then tectonic=tectonic_class.plate
			If r1>=9 Then tectonic=tectonic_class.platelet
		EndIf
		If tectonic_activity>=5.0 Then
			If r1=1 Then tectonic=tectonic_class.plastic
			If r1=2 Then tectonic=tectonic_class.plate
			If r1>=3 And r1<=7 Then tectonic=tectonic_class.platelet
			If r1>=8 Then tectonic=tectonic_class.extreme
		EndIf
		'create magnetic field
		If tidal_locked=TRUE Then
			magnetic_factor=10*1.0/Sqr(orbit_periode/24)*(density*density)*Sqr(mass)/age
		Else
			magnetic_factor=10*1.0/Sqr(rotation_periode/24)*(density*density)*Sqr(mass)/age
		EndIf
		If core_type>=core_class.ice And core_type<=core_class.SI_ice Then
			magnetic_factor*=0.5
		EndIf
		r1=rndRange(1,10)
		r2=rndRange(1,10)
		If magnetic_factor<0.05 Then magnetic_field=0
		If magnetic_factor>=0.05 And magnetic_factor<0.5 Then
			If r1>=1 And r1<=5 Then magnetic_field=0
			If r1>=6 And r1<=7 Then magnetic_field=r2*0.001
			If r1>=8 And r1<=9 Then magnetic_field=r2*0.002
			If r1>=10 Then magnetic_field=r2*0.01
		EndIf
		If magnetic_factor>=0.5 And magnetic_factor<1.0 Then
			If r1>=1 And r1<=3 Then magnetic_field=0
			If r1>=4 And r1<=5 Then magnetic_field=r2*0.001
			If r1>=6 And r1<=7 Then magnetic_field=r2*0.002
			If r1>=8 And r1<=9 Then magnetic_field=r2*0.01
			If r1>=10 Then magnetic_field=r2*0.05
		EndIf
		If magnetic_factor>=1.0 And magnetic_factor<2.0 Then
			If r1>=1 And r1<=3 Then magnetic_field=r2*0.001
			If r1>=4 And r1<=5 Then magnetic_field=r2*0.002
			If r1>=6 And r1<=7 Then magnetic_field=r2*0.01
			If r1>=8 And r1<=9 Then magnetic_field=r2*0.05
			If r1>=10 Then magnetic_field=r2*0.1
		EndIf
		If magnetic_factor>=2.0 And magnetic_factor<4.0 Then
			If r1>=1 And r1<=3 Then magnetic_field=r2*0.05
			If r1>=4 And r1<=5 Then magnetic_field=r2*0.1
			If r1>=6 And r1<=7 Then magnetic_field=r2*0.2
			If r1>=8 And r1<=9 Then magnetic_field=r2*0.3
			If r1>=10 Then magnetic_field=r2*0.5
		EndIf
		If magnetic_factor>=4.0 Then
			If r1>=1 And r1<=3 Then magnetic_field=r2*0.1
			If r1>=4 And r1<=5 Then magnetic_field=r2*0.2
			If r1>=6 And r1<=7 Then magnetic_field=r2*0.3
			If r1>=8 And r1<=9 Then magnetic_field=r2*0.5
			If r1>=10 Then magnetic_field=r2*1.0
		EndIf
	EndIf
	'create magnetic field for giants and jovians
	r1=rndRange(1,10)
	r2=rndRange(1,10)
	If planet_type>=planet_class.giant And planet_type<=planet_class.jovian Then
		If mass<50 Then
			If r1=1 Then magnetic_field=r2*0.1
			If r1>=2 And r1<=4 Then magnetic_field=r2*0.25
			If r1>=5 And r1<=7 Then magnetic_field=r2*0.5
			If r1>=8 And r1<=9 Then magnetic_field=r2*0.75
			If r1>=10 Then magnetic_field=r2*1.0
		EndIf
		If mass>=50 And mass<200 Then
			If r1=1 Then magnetic_field=r2*0.25
			If r1>=2 And r1<=4 Then magnetic_field=r2*0.5
			If r1>=5 And r1<=7 Then magnetic_field=r2*0.75
			If r1>=8 And r1<=9 Then magnetic_field=r2*1.0
			If r1>=10 Then magnetic_field=r2*1.5
		EndIf
		If mass>=200 And mass<500 Then
			If r1=1 Then magnetic_field=r2*0.5
			If r1>=2 And r1<=4 Then magnetic_field=r2*1.0
			If r1>=5 And r1<=7 Then magnetic_field=r2*1.5
			If r1>=8 And r1<=9 Then magnetic_field=r2*2.0
			If r1>=10 Then magnetic_field=r2*3.0
		EndIf
		If mass>=500 Then
			If r1=1 Then magnetic_field=r2*1.5
			If r1>=2 And r1<=4 Then magnetic_field=r2*2.5
			If r1>=5 And r1<=7 Then magnetic_field=r2*5.0
			If r1>=8 And r1<=9 Then magnetic_field=r2*10.0
			If r1>=10 Then magnetic_field=r2*25.0
		EndIf
	EndIf
	'generate asteorid
	If planet_type>=planet_class.asteorid Then
		r1=rndRange(1,10)
		If orbit>inner Then r1+=6
		If orbit<hab_min Then r1-=2
		If density>=0.6 And density<0.8 Then r1-=1
		If density>=0.8 And density<1.0 Then r1-=2
		If density>=1.0 And density<1.2 Then r1-=3
		If density>=1.2 Then r1-=5
		If r1<-1 Then core_type=asteorid_class.M
		If r1>=-1 And r1<=5 Then core_type=asteorid_class.S
		If r1>=6 And r1<=10 Then core_type=asteorid_class.C
		If r1>=11 Then core_type=asteorid_class.Ice
		r1=rndRange(1,10)
		r2=rndRange(1,10)
		If orbit<=inner Then
			r1-=1
		Else
			r1+=2
		EndIf
		If orbit_both=TRUE Then r1+=2
		If age>7 Then r1-=1
		r1+=abudance
		If r1<5 Then mass=0.0001*r2
		If r1>=5 And r1<=6 Then mass=0.001*r2
		If r1>=7 And r1<=8 Then mass=0.01*r2
		If r1>=9 And r1<=10 Then mass=0.1*r2
		If r1>=11 Then mass=1*r2
	EndIf
	'lays it in habitable zone
	If orbit>=hab_min And orbit<=hab_max Then habitable=TRUE
	'calculate base surface temperature
	base_temperature = 255/Sqr(orbit/Sqr(lum))


	'create moons
	Dim n As Integer=0
	If tidal_locked=FALSE Then
		r1=rndRange(1,10)
		If orbit>inner Then r1+=5
		If planet_type=planet_class.chunk Then
			If r1>=-4 And r1<=9 Then n=0
			If r1>=10 And r1<=13 Then n=1
			If r1>=14 Then n=1
		EndIf
		If planet_type=planet_class.terestrial Then
			If r1>=-4 And r1<=5 Then n=0
			If r1>=6 And r1<=7 Then n=1
			If r1>=8 And r1<=9 Then n=rndRange(1,2)
			If r1>=10 And r1<=13 Then n=rndRange(1,5)
			If r1>=14 Then n=rndRange(1,10)
		EndIf
		If planet_type=planet_class.giant Or planet_type=planet_class.jovian Then
			If r1>=-4 And r1<=0 Then n=0
			If r1>=1 And r1<=5 Then n=rndRange(1,5)
			If r1>=6 And r1<=7 Then n=rndRange(1,10)
			If r1>=8 And r1<=9 Then n=rndRange(1,10)+5
			If r1>=10 And r1<=13 Then n=rndRange(1,10)+10
			If r1>=14 Then n=rndRange(1,10)+20
		EndIf
		create_moons(n)
	EndIf
	If nr_moons>0 Then
		For i As UInteger=0 To nr_moons-1
			moon[i].generate_moon(inner,hab_min,hab_max,abudance,age,lum,mass,density,orbit,tidal_locked)
		Next
	EndIf
	'remove_moons(radius)
End Sub

Sub moon_t.generate_moon(inner As Double,hab_min As Double,hab_max As Double,abudance As Integer,age As Double,lum As Double,ma As Double,d As Double,o As Double,tidal_lock As boolean)
	Dim r1 As Integer=rndRange(1,10)
	If r1>=1 And r1<=4 Then orbit=1+rndRange(1,10)*0.5
	If r1>=5 And r1<=7 Then orbit=6+rndRange(1,10)
	If r1>=8 And r1<=9 Then orbit=16+rndRange(1,10)*3
	If r1>=10 Then orbit=45+rndRange(1,100)*3

	If o<inner Then
		density=0.3+rndRange(1,10)*0.1
	Else
		density=0.1+rndRange(1,10)*0.05
	EndIf
	roche_limit=2.456*(d/density)^0.33
	r1=rndRange(1,100)
	If abudance<0 Then r1+=abudance*2
	If abudance>0 Then r1+=abudance
	If r1>=-4 And r1<=64 Then
		moon_type=moon_class.tiny_chunk
		radius=rndRange(1,10)*10
	EndIf
	If r1>=65 And r1<=84 Then
		moon_type=moon_class.chunk
		radius=rndRange(1,10)*100
	EndIf
	If r1>=85 And r1<=94 Then
		moon_type=moon_class.large_chunk
		radius=1000+rndRange(1,10)*100
	EndIf
	If r1>=95 And r1<=99 Then
		moon_type=moon_class.small_terrestrial
		radius=2000+rndRange(1,10)*200
	EndIf
	If r1>=100 Then
		moon_type=moon_class.terrestrial
		radius=4000+rndRange(1,10)*400
	EndIf
	If orbit<=roche_limit And moon_type>=moon_class.tiny_chunk And moon_type<=moon_class.large_chunk Then
		moon_type=moon_class.ring
	EndIf
	mass=((radius/6380)*(radius/6380)*(radius/6380))/density
	gravity= mass/((radius/6380)*(radius/6380))
	orbit_periode=Sqr((((orbit/400000)*(orbit/400000)*(orbit/400000))*793.64/mass))
End Sub
Sub print_moon_data(galaxy As galaxy_t,snr As Integer,pnr As Integer,mnr As integer)
	Dim moon As moon_t=galaxy.systems[galaxy.xp][galaxy.yp].star[snr-1].planet[pnr-1].moon[mnr-1]
	DrawText(75,1,Str(moon.moon_type),&hffffffff)
	DrawText(75,2,Str(moon.orbit),&hffffffff)
	DrawText(75,3,Str(moon.orbit_periode),&hffffffff)
	DrawText(75,4,Str(moon.radius),&hffffffff)
	DrawText(75,5,Str(moon.density),&hffffffff)
	DrawText(75,6,Str(moon.mass),&hffffffff)
	DrawText(75,7,Str(moon.gravity),&hffffffff)
	DrawText(75,8,Str(moon.exentry),&hffffffff)
	DrawText(75,9,Str(moon.axial_tilt),&hffffffff)
	DrawText(75,10,Str(moon.rotation_periode),&hffffffff)
	DrawText(75,11,Str(moon.escape_velocity),&hffffffff)
	DrawText(75,12,Str(moon.roche_limit),&hffffffff)
	DrawText(75,13,Str(moon.tidal_lock),&hffffffff)
	DrawText(75,14,Str(moon.tidal_locked),&hffffffff)
	DrawText(75,15,Str(moon.core_type),&hffffffff)
	DrawText(75,16,Str(moon.tectonic_activity),&hffffffff)
	DrawText(75,17,Str(moon.tectonic),&hffffffff)
	DrawText(75,18,Str(moon.magnetic_factor),&hffffffff)
	DrawText(75,19,Str(moon.magnetic_field),&hffffffff)
End Sub
Sub print_planet_data(galaxy As galaxy_t,snr As Integer,pnr As Integer)
	Dim planet As planet_t=galaxy.systems[galaxy.xp][galaxy.yp].star[snr-1].planet[pnr-1]
	DrawText(75,1,Str(planet.planet_type),&hffffffff)
	DrawText(75,2,Str(planet.orbit),&hffffffff)
	DrawText(75,3,Str(planet.orbit_periode),&hffffffff)
	DrawText(75,4,Str(planet.radius),&hffffffff)
	DrawText(75,5,Str(planet.density),&hffffffff)
	DrawText(75,6,Str(planet.mass),&hffffffff)
	DrawText(75,7,Str(planet.gravity),&hffffffff)
	DrawText(75,8,Str(planet.exentry),&hffffffff)
	DrawText(75,9,Str(planet.axial_tilt),&hffffffff)
	DrawText(75,10,Str(planet.rotation_periode),&hffffffff)
	DrawText(75,11,Str(planet.escape_velocity),&hffffffff)
	DrawText(75,12,Str(planet.tidal_lock),&hffffffff)
	DrawText(75,13,Str(planet.tidal_locked),&hffffffff)
	DrawText(75,14,Str(planet.core_type),&hffffffff)
	DrawText(75,15,Str(planet.tectonic_activity),&hffffffff)
	DrawText(75,16,Str(planet.tectonic),&hffffffff)
	DrawText(75,17,Str(planet.magnetic_factor),&hffffffff)
	DrawText(75,18,Str(planet.magnetic_field),&hffffffff)
	DrawText(75,19,Str(planet.base_temperature),&hffffffff)
	DrawText(75,20,Str(planet.habitable),&hffffffff)
	DrawText(75,21,Str(planet.solar_day),&hffffffff)
	DrawText(75,22,Str(planet.nr_moons),&hffffffff)
End Sub
Sub print_star_data(galaxy As galaxy_t,snr As Integer)
	Dim star As star_t=galaxy.systems[galaxy.xp][galaxy.yp].star[snr-1]
	Dim tstr As String="STARCLASS: " & Left(star_class_str(star.star_class),1) & Str(star.star_specification) & Right(star_class_str(star.star_class),4)
	TO_ClearText(textedit)
	TO_AppendLine(textedit,"NAME: ")
	TO_AppendLine(textedit,tstr)
	TO_AppendLine(textedit,"")
	TO_AppendLine(textedit,"Size: " & Left(Str(star.radius),6) & " Sol Radii")
	TO_AppendLine(textedit,"Mass: " & Left(Str(star.mass),6) & " Sols")
	TO_AppendLine(textedit,"Temperature: " & Str(star.temperature) & " K")
	TO_AppendLine(textedit,"Luminousity: " & Left(Str(star.Luminousity),6) & " Lumen")
	TO_AppendLine(textedit,"Age: " & Str(star.age) & " GY")
	TO_AppendLine(textedit,"LifeSpan: " & Left(Str(star.life_span),6) & " GYs left.")
	TO_AppendLine(textedit,"Habitable Zone: " & Left(Str(star.habitable_zone_min),6) & " AU - " & Left(Str(star.habitable_zone_max),6) & " AU")
	If star.orbit<>0 Then 
	TO_AppendLine(textedit,"")
	TO_AppendLine(textedit,"It orbits his partner at " & Str(Abs(star.orbit)) & " AU.")		
	TO_AppendLine(textedit,"The orbit periode is " & Left(Str(star.orbit_periode),6) & " Years.")		
	EndIf
	If star.nr_planets>0 Then
	TO_AppendLine(textedit,"")
		TO_AppendLine(textedit,"Also he has " & Str(star.nr_planets) & " Planets.")
		If star.nr_planets>0 then			
		Dim x As Integer=0
		For i As UInteger=0 To star.nr_planets-1
			If star.planet[i].orbit_both Then x+=1
		Next
		If x>0 Then TO_AppendLine(textedit,Str(x) & " of them orbit both Stars.")		
		EndIf
	EndIf
	For r As Integer=0 To 5
	For i As Integer=0 To 360
	DrawText(80+Sin(i*degToRad)*r,7+Cos(i*degToRad)*r,Chr(dither_chars(r)),Temperature2RGB(star.temperature+((-0.5*Rnd)*(star.temperature)))And &h00ffffff Or RGBA(0,0,0,(r+1)*32))
	Next
	Next
'	DrawText(75,12,Str(star.inner_zone),&hffffffff)
	UpdateGadget(textedit)
End Sub