#Ifndef __utils__
#define __utils__
/'
      math, geometry and other useful numerical stuff

      10/7/2017: removed all OpenGL-related stuff and the x86 assembler implementations of
         floating-point modulus operator, and moved them to their own files (again).
   '/
'' some convenience macros
#define max( a, b )                  iif( a > b, a, b )
#define min( a, b )                  iif( a < b, a, b )
#define clamp( mn, mx, v )      iif( v < mn, mn, iif( v > mx, mx, v ) )
#define wrap( wrapValue, v )   ( ( v ) + wrapValue ) mod wrapValue

'' useful constants
const as double pi = 4 * atn( 1 )
const as double twoPi = 2 * pi
const as double halfPi = pi / 2

const as double degToRad = pi / 180
const as double radToDeg = 180 / pi
const as double epsilon = 0.00000001
Const As Double euler = 2.71828182845904523536028747135266249775724709369995
'' used to express angles in another unit
#define radians( ang )   ang * degToRad
#define degrees( ang )   ang * radToDeg

'' functions to return a delimited random value (uses FB implementation which
'' is a Mersenne Twister, can't remember the classification
declare function rndRange overload( byval as integer, byval as integer ) as integer
'declare function rndRange( byval as single, byval as single ) as single
'declare function rndRange( byval as double, byval as double ) as double
Declare function sigmoid( byval as double, byval as double ,ByVal As Double) as Double'range -8 - +8
Declare Function mapa(x As Double, in_min As Double, in_max As Double, out_min As Double, out_max As double) As Double
Declare Function density(x As Double,y As Double=0.0,o As Double=1.0) As Double'range -4 - +4
Declare Function distance3d(x1 As Double,y1 As Double,z1 As double, x2 As Double,y2 As Double,z2 As double) As Double

Declare Sub DrawTile(x As Integer, y As Integer, farbe As UInteger)
Declare Sub DrawText(x As Integer, y As Integer, txt As string,farbe As UInteger)
Declare Sub DrawShadowedText(x As Integer, y As Integer, txt As String, farbe As uInteger, shadowfarbe As uInteger,pitch As Integer=2)

Declare Function CenterX(ct As String) As Integer
Declare Function CenterY() As Integer

Sub DrawTile(x As Integer, y As Integer, farbe As UInteger)
	Draw String (x*tile_w,y*tile_h),Chr(219),farbe
End Sub
Sub DrawText(x As Integer, y As Integer, txt As string,farbe As UInteger)
	Draw String (x*tile_w,y*tile_h),txt,farbe
End Sub
Sub DrawShadowedText(x As Integer, y As Integer, txt As String,farbe As uInteger,shadowfarbe As uInteger,pitch As Integer=2)
	Draw String (x*tile_w+pitch,y*tile_h+pitch),txt,shadowfarbe
	Draw String (x*tile_w,y*tile_h),txt,farbe
End Sub


Function CenterX(ct As string) As Integer
	Return ((scr_w / 2) - (Len(ct)*tile_w / 2))\tile_w
End function
Function CenterY() As Integer
	Return ((scr_h / 2) - (tile_h / 2))\tile_h
End Function



public function rndRange( byval mn as integer, byval mx as integer ) as integer
	return int( rnd() * ( mx + 1 - mn ) + mn )
end function

'public function rndRange( byval mn as single, byval mx as single ) as single
'	return rnd() * ( mx - mn ) + mn
'end function
'
'public function rndRange( byval mn as double, byval mx as double ) as double
'	return rnd() * ( mx - mn ) + mn
'end function
public function sigmoid( byval mn as double, byval mx as Double,mo As Double ) as Double
	Return 1.0/(1.0+((mn^2)/mx)+mo)
	'   	Return 1.0/(1.0+(mn/mx+mo)^2)
	'   	Return 1.0/(1.0+Exp(-mn/mx+mo))
End Function
Public Function mapa(x As Double, in_min As Double, in_max As Double, out_min As Double, out_max As double) As double
	return (x - in_min) * (out_max - out_min) / (in_max - in_min) + out_min
End Function
Public Function density(x As Double,y As Double=0.0,o As Double=1.0) As Double
	Return (1.0/(Sqr(2*3.14*(o*o))))*Exp(-(((x-y)*(x-y))/(2*(o*o))))
End Function
Public Function distance3d(x1 As Double,y1 As Double,z1 As double, x2 As Double,y2 As Double,z2 As Double) As Double
	Return Sqr(((x2-x1)^2 + (y2-y1)^2 + (z2-z1)^2))
End Function



'**
'* A more accurate version algorithm based on a different curve fit to the
'* original RGB to Kelvin data.
' * Input: color temperature in degrees Kelvin
' * Output: json object of red, green and blue components of the Kelvin temperature
'*/
Function Temperature2RGB(kelvin As double) As UInteger

	Dim As double temperature = kelvin / 100.0
	Dim As Integer red, green, blue

	if (temperature < 66.0) Then
		red = 255
	else
		'// a + b x + c Log[x] /.
		'// {a -> 351.97690566805693`,
		'// b -> 0.114206453784165`,
		'// c -> -40.25366309332127
		'//x -> (kelvin/100) - 55}
		red = temperature - 55.0
		red = 351.97690566805693+ 0.114206453784165 * red - 40.25366309332127 * Log(red)
		If (red < 0) Then red = 0
		If (red > 255) Then red = 255
	EndIf

	'/* Calculate green */

	if (temperature < 66.0) Then

		'// a + b x + c Log[x] /.
		'// {a -> -155.25485562709179`,
		'// b -> -0.44596950469579133`,
		'// c -> 104.49216199393888`,
		'// x -> (kelvin/100) - 2}
		green = temperature - 2
		green = -155.25485562709179 - 0.44596950469579133 * green + 104.49216199393888 * Log(green)
		If (green < 0) Then green = 0
		If (green > 255) Then green = 255

	else

		'// a + b x + c Log[x] /.
		'// {a -> 325.4494125711974`,
		'// b -> 0.07943456536662342`,
		'// c -> -28.0852963507957`,
		'// x -> (kelvin/100) - 50}
		green = temperature - 50.0
		green = 325.4494125711974 + 0.07943456536662342 * green - 28.0852963507957 * Log(green)
		If (green < 0) Then green = 0
		If (green > 255) Then green = 255

	endif

	'  /* Calculate blue */

	if (temperature >= 66.0) Then
		blue = 255
	else

		if (temperature <= 20.0) Then
			blue = 0
		else

			'// a + b x + c Log[x] /.
			'// {a -> -254.76935184120902`,
			'// b -> 0.8274096064007395`,
			'// c -> 115.67994401066147`,
			'// x -> kelvin/100 - 10}
			blue = temperature - 10
			blue = -254.76935184120902 + 0.8274096064007395 * blue + 115.67994401066147 * log(blue)
			If (blue < 0) Then blue = 0
			If (blue > 255) Then blue = 255
		EndIf
	EndIf

	return RGBA(red,green,blue,255)
End Function

'/**
' convert an rgb in JSON format into to a Kelvin color temperature
' */
'function rgb2colorTemperature(c As uinteger) As Double
'var temperature, testRGB;
'var epsilon=0.4;
'var minTemperature = 1000;
'var maxTemperature = 40000;
'while (maxTemperature - minTemperature > epsilon) {
'temperature = (maxTemperature + minTemperature) / 2;
'testRGB = colorTemperature2rgb(temperature);
'if ((testRGB.blue / testRGB.red) >= (rgb.blue / rgb.red)) {
'maxTemperature = temperature;
'} else {
'minTemperature = temperature;
'}
'}
'return temperature
'End Function

Sub draw_window(x As Integer,y As Integer,x_size As Integer,y_size As integer)
	For i As UInteger=1 To x_size-2
		DrawText(x+i, y, Chr(205),&hff00ff00)
		DrawText(x+i, y+y_size-1, Chr(205),&hff00ff00)
	Next
	For j As UInteger=1 To y_size-2
		DrawText(x, y+j, Chr(186),&hff00ff00)
		DrawText(x+x_size-1, y+j, Chr(186),&hff00ff00)
	Next
End Sub
#EndIf